<template>
  <div class="authorityManagement_box">
    <My-bread :list="['数据管理', '样式管理', '添加样式']"></My-bread>
    <el-divider />
    <div class="inquire">
      <el-form ref="formData1" :model="updateForm" :inline="true">
        <el-form-item>
          <el-link
            style="margin-left: 10px; margin-right: 20px"
            :underline="false"
            @click="returnStyle"
            title="返回"
            ><i class="el-icon-d-arrow-left"></i
          ></el-link>
          <el-button type="primary" size="small" @click="showCatalog()"
            >目录</el-button
          >
        </el-form-item>
        <el-form-item>
          <el-tooltip
            :content="
              updateForm.cataName == '' ? '未选择目录' : updateForm.cataName
            "
            placement="top-start"
          >
            <el-input
              v-model="updateForm.cataName"
              disabled
              class="firstInput"
            />
          </el-tooltip> </el-form-item
        ><el-form-item>
          <span>类型选择</span>
        </el-form-item>
        <el-form-item>
          <el-select v-model="updateForm.type" clearable placeholder="请选择">
            <el-option
              v-for="item in options"
              :key="item.value"
              :label="item.label"
              :value="item.value"
            >
            </el-option>
          </el-select>
        </el-form-item>
        <el-form-item>
          <span>版本</span>
        </el-form-item>
        <el-form-item>
          <el-input v-model="updateForm.version" />
        </el-form-item>

        <el-form-item>
          <el-upload
            :on-remove="handleRemove"
            :http-request="uploadFile"
            :file-list="fileList"
            multiple
            ref="upload"
            class="upload"
            action="http://192.168.20.106/LFServer/Meta/Upload"
            :auto-upload="false"
            :headers="headers"
            :accept="acceptItem"
          >
            <template #trigger>
              <el-button type="primary" size="small">选择</el-button>
            </template>
            <el-button
              class="ml-3"
              type="success"
              size="small"
              @click="submitUpload"
            >
              上传
            </el-button>
            <el-link
              title="删除数据"
              :underline="false"
              @click="delStyleData"
              style="margin-left: 300px"
              ><i class="el-icon-delete"></i
            ></el-link>
          </el-upload>
        </el-form-item>
      </el-form>
    </div>
    <div class="table_box">
      <el-table
        :data="tableData"
        border
        style="width: 100%"
        fit
        height="99%"
        @selection-change="handleSelectionChange"
      >
        <el-table-column type="selection" width="55" />
        <el-table-column width="50" type="index" label="序号" />
        <el-table-column min-width="150" prop="name" label="数据名称" />
        <el-table-column min-width="200" prop="path" label="所属目录" />
        <el-table-column min-width="100" prop="create_time" label="创建时间" />
        <el-table-column min-width="100" prop="create_user" label="创建人员" />
        <el-table-column min-width="80" prop="type" label="数据类型" />
        <el-table-column min-width="80" prop="format" label="数据格式" />
        <el-table-column min-width="80" prop="up_unit" label="上传单位" />
        <el-table-column min-width="50" prop="status" label="数据状态" />
        <el-table-column min-width="50" prop="version" label="数据版本" />
      </el-table>
    </div>
    <div class="pagination_box" style="margin-top: 20px; margin-left: 400px">
      <el-pagination
        @size-change="handleSizeChange"
        @current-change="handleCurrentChange"
        :current-page="currentPage4"
        :page-sizes="[10, 20, 50, 100]"
        :page-size="pageNum"
        layout="total, sizes, prev, pager, next, jumper"
        :total="count"
      >
      </el-pagination>
    </div>
    <div class="leftTree" v-show="showCata">
      <div class="treeBox">
        <catalogueTree></catalogueTree>
      </div>
      <div class="btnBox">
        <el-button type="primary" size="small" @click="selectCataName"
          >确定</el-button
        >
        <el-button type="primary" size="small" @click="closeCata"
          >取消</el-button
        >
      </div>
    </div>
    <!-- <div class="infoBox" v-show="showinfoBox">
      <el-card class="box-card">
        <div slot="header" class="clearfix">
          <span>详细信息</span>
          <div style="float: right; cursor: pointer" @click="closeDetial">
            <i class="el-icon-close"></i>
          </div>
        </div>
        <div class="contentBox">
          <p>数据名称：{{ itemdetail.name }}</p>
          <el-divider></el-divider>
          <p>所属目录：{{ itemdetail.path }}</p>
          <el-divider></el-divider>
          <p>创建时间：{{ itemdetail.create_time }}</p>
          <el-divider></el-divider>
          <p>创建人员：{{ itemdetail.create_user }}</p>
          <el-divider></el-divider>
          <p>数据类型：{{ itemdetail.type }}</p>
          <el-divider></el-divider>
          <p>数据格式：{{ itemdetail.format }}</p>
          <el-divider></el-divider>
          <p>上传单位：{{ itemdetail.up_unit }}</p>
          <el-divider></el-divider>
          <p>数据状态：{{ itemdetail.status }}</p>
          <el-divider></el-divider>
          <p>数据版本：{{ itemdetail.version }}</p>
        </div>
      </el-card>
    </div> -->
  </div>
</template>

<script>
import { StyleQuery, StyleCounnt, DeletestStyle } from "../../api/api";
import catalogueTree from "../../components/catalogueTree.vue";
import MyBread from "../../components/MyBread.vue";
export default {
  name: "dataUpdata",
  components: {
    MyBread,
    catalogueTree,
  },
  data() {
    return {
      options: [
        {
          value: "DEM",
          label: "图片",
        },
        {
          value: "File",
          label: "工程文件",
        },
      ],
      value: "",
      showinfoBox: false,
      itemdetail: {},
      fileList: [],
      headers: { "Content-Type": "multipart/form-data" },
      acceptItem: "",
      showCata: false,
      updateForm: {
        path_id: "",
        cataName: "",
        version: "",
        type: "",
        name: "",
      },
      multipleSelection: [],
      tableData: [],
      currentPage4: 0,
      pageSize: 1,
      pageNum: 10,
      count: 0,
      searchName: "",
    };
  },
  created() {
    this.startFromData();
  },
  watch: {
    "updateForm.type": {
      immediate: true,
      handler(val) {
        switch (val) {
          case "DEM":
            this.acceptItem = ".jpg,.png";
            break;
          case "File":
            this.acceptItem = ".fly,.tif,.emp,.edp";
            break;
        }
      },
    },
  },
  methods: {
    startFromData() {
      this.count = 0;
      this.pageSize = 1;
      this.pageNum = 10;

      this.getStyleData(this.pageNum, this.pageSize, this.searchName);
      this.getStyleDataCount(this.searchName);
    },
    returnStyle() {
      this.$router.push("/styleManage");
    },
    // 请求数据
    getStyleData(size, index,name) {
      StyleQuery(size, index,name).then((res) => {
        console.log(res);
        this.tableData = res.data;
      });
    },
    // 请求数据
    getStyleDataCount(name) {
      StyleCounnt(name).then((res) => {
        this.count = res.data;
      });
    },
    // 获取多选
    handleSelectionChange(val) {
      this.multipleSelection = val;
    },
    delStyleData() {
      var std = [];
      for (var i in this.multipleSelection) {
        std.push(this.multipleSelection[i].id);
      }
      this.$confirm("确定是否删除所选内容?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          DeletestStyle(std);
          this.$message({
            type: "success",
            message: "删除成功!",
          });
          this.startFromData();
        })
        .catch(() => {});
    },
    // 显示目录
    showCatalog() {
      this.showCata = true;
    },
    // 选择目录
    selectCataName() {
      this.updateForm.cataName = this.$store.state.catalogueName;
      this.updateForm.path_id = this.$store.state.cataNode.id;
      this.$store.commit("changeCata", ""); //清空state的面包屑
      this.$store.commit("changeNode", ""); //清空state的节点对象
      this.showCata = false;
    },
    closeCata() {
      this.showCata = false;
    },

    submitUpload() {
      if (this.updateForm.path_id == "" || this.updateForm.type == "") {
        alert("请选择数据类型或上传目录");
        this.$refs.upload.abort();
        return false;
      } else {
        this.$refs.upload.submit();
      }
    },
    uploadFile(item) {
      //上传文件的需要formdata类型;所以要转
      let FormDatas = new FormData();
      FormDatas.append("file", item.file);
      let name = FormDatas.get("file").name.split(".")[0];
      let path_id = this.updateForm.path_id;
      let version = this.updateForm.version;
      let type = this.updateForm.type;
      let url = `http://192.168.20.106/LFServer/Meta/Upload?path_id=${path_id}&type=${type}&version=${version}&name=${name}`;
      // console.log(url);
      this.$http({
        method: "post",
        url,
        headers: this.headers,
        timeout: 30000,
        data: FormDatas,
      }).then((res) => {
        if (res.status == 200 && res.data.length != 0) {
          this.$message({
            message: "上传成功",
            type: "success",
          });
          this.getMetaData(10, 1);
        } else {
          alert("上传失败");
          console.log(res);
        }
      });
    },
    // 文件列表移除文件时的钩子
    handleRemove(file, fileList) {
      console.log(file, fileList);
    },
    handleSizeChange(val) {
      this.pageNum = val;
      this.getStyleData(this.pageNum, 1, this.searchName);
      this.getStyleDataCount();
    },
    handleCurrentChange(val) {
      this.pageSize = val;
      this.getStyleData(this.pageNum, this.pageSize, this.searchName);
      this.getStyleDataCount();
    },
    // showDetail(index, row) {
    //   // console.log(index, row);
    //   this.showinfoBox = true;
    //   this.itemdetail = row;
    // },
    // handleDelete(index, row) {
    //   // console.log(index, row);
    //   this.$confirm("确定是否删除?", "提示", {
    //     confirmButtonText: "确定",
    //     cancelButtonText: "取消",
    //     type: "warning",
    //   })
    //     .then(() => {})
    //     .catch(() => {});
    // },
    // closeDetial() {
    //   this.showinfoBox = false;
    //   this.itemdetail = {};
    // },
  },
};
</script>
<style lang="less" scoped>
//@import url(); 引入公共css类
.authorityManagement_box {
  background: rgb(240, 242, 245);
  border-radius: 10px;
  height: 100%;
  padding: 10px;
  box-sizing: border-box;
  overflow: hidden;
  .inquire {
    margin: 10px auto;
    background: #fff;
    border-radius: 5px;
    border: 1px solid rgb(202, 201, 204);
    height: 90px;
    .el-form-item {
      margin: 5px;
    }
    .el-input {
      width: 307px;
    }

    .ml-3 {
      margin-left: 10px;
    }
    .upload {
      /deep/ .el-upload-list {
        width: 79vw;
        height: 27px;
        margin: 0;
        margin-left: 0px;
        padding: 0;
        list-style: none;
        // background: #bfa;
        position: absolute;
        left: -53vw;
        top: 5vh;
        z-index: 10;
        overflow: auto;
        display: flex;
        flex-wrap: wrap;
      }
      /deep/ .el-upload-list__item {
        margin-top: 0px;
        transition: all 0.5s cubic-bezier(0.55, 0, 0.1, 1);
        font-size: 14px;
        color: #606266;
        line-height: 1.8;
        // margin-top: 5px;
        position: relative;
        box-sizing: border-box;
        border-radius: 4px;
        width: 15%;
      }
    }
  }
  .table_box {
    height: 73%;
    overflow: auto;
    padding: 10px;
    background: #fff;
    border-radius: 5px;
    border: 1px solid rgb(202, 201, 204);
    .el-table /deep/ .el-table__header-wrapper tr th {
      background-color: rgb(255, 255, 255) !important;
      color: rgb(0, 0, 0);
    }
    // 修改每行样式：
    .el-table /deep/ .el-table__row {
      background-color: rgba(255, 255, 255) !important;
      color: rgb(0, 0, 0);
    }
    .el-table /deep/ .el-table__body tr.current-row > td {
      background-color: rgb(211, 211, 211) !important;
    }
    .el-table /deep/ .el-table__body tr:hover > td {
      background-color: rgb(211, 211, 211) !important;
    }
    // 修改表格每行边框的样式：
    .el-table /deep/ td,
    .el-table /deep/ th.is-leaf {
      border-bottom: 1px solid #eee;
      border-right: 1px solid #eee;
    }
    .el-table /deep/ .el-table__cell {
      padding: 8px 0;
    }
    // 设置表格每行的高度：
    .el-table /deep/ .el-table__header tr,
    .el-table /deep/ .el-table__header th {
      height: 50px;
    }
    .el-table__body tr,
    .el-table__body td {
      height: 50px;
      padding: 0;
    }
    // 设置表格边框颜色：

    .el-table--border::after,
    .el-table--group::after {
      width: 0;
    }
    .el-table::before {
      height: 0;
    }
  }
  .leftTree {
    position: absolute;
    z-index: 10;
    top: 100px;
    left: 600px;
    width: 400px;
    height: 600px;
    background: #f0f2f5;
    border: 1px solid #000;
    .treeBox {
      height: 550px;
      overflow: auto;
      /deep/ .el-tree-node__content:hover {
        background-color: rgb(153, 153, 153);
      }
    }
    .btnBox {
      width: 123px;
      margin: 10px auto 0;
      // background-color: red;
    }
  }
  .infoBox {
    width: 500px;
    border: 1px solid #eee;
    position: absolute;
    z-index: 100;
    top: 15%;
    right: 25%;
    background-color: #fff;
    .el-card {
      background-color: transparent;
      span {
        font-size: 16px;
        font-weight: 600;
      }
    }
    .contentBox {
      margin: 0 aotu 10px;
      p {
        // background-color: #bfa;
        // margin-bottom: 10px;
        font-size: 14px;
      }
    }
  }
}
</style>
